/*
 * image.cpp
 *
 *  Created on: 7 janv. 2021
 *      Author: kerhoas
 */

#include "image.hpp"

#define AT_METHODE 1
#define MAT_ITERATOR 2
#define C_POINTER 3

#define ALGO  AT_METHODE

using namespace cv;
using namespace std;
//=====================================================================
//				CONVERSION EN NEGATIF
// R <- 255-R
// V <- 255-V
// B <- 255-B
//=====================================================================
void Negative(Mat &image)
{
//.....................................................................
#if ALGO == AT_METHODE

	if (image.channels() == 1) // gray-level image
				{
						for( int i = 0; i < image.rows; ++i)
							   for( int j = 0; j < image.cols; ++j )
							   {
								   image.at<uchar>(i,j) = 255 -image.at<uchar>(i,j) ;
							   }
				}
	else if (image.channels() == 3) // color image
				{
					   for( int i = 0; i < image.rows; ++i)
							  for( int j = 0; j < image.cols; ++j )
								  {
									 image.at<Vec3b>(i,j)[0] = 255-image.at<Vec3b>(i,j)[0];
									 image.at<Vec3b>(i,j)[1] = 255-image.at<Vec3b>(i,j)[1];
									 image.at<Vec3b>(i,j)[2] = 255-image.at<Vec3b>(i,j)[2];
								  }
				}
//.....................................................................
#elif ALGO == MAT_ITERATOR
	if (image.channels() == 1) // gray-level image
				{
					   MatIterator_<uchar> it, end;
						for( it = image.begin<uchar>(), end = image.end<uchar>(); it != end; ++it)
							*it = 255-*it;
				}
	else if (image.channels() == 3) // color image
				{
					  MatIterator_<Vec3b> it, end;										// Matiterator pour récupérer l'adresse de chaque pixel
						for( it = image.begin<Vec3b>(), end = image.end<Vec3b>(); it != end; ++it) // On parcourt l'ensemble des pixels
						{
							(*it)[0] = 255-(*it)[0];     // Pour un pixel couleur --> 3 composantes
							(*it)[1] = 255-(*it)[1];
							(*it)[2] = 255-(*it)[2];
						}
				}

//.....................................................................
#elif ALGO == C_POINTER

			int channels = image.channels();

			int nRows = image.rows;
			int nCols = image.cols * channels;

			int i,j;
			uchar* p;
			for( i = 0; i < nRows; ++i)
			{
				p = image.ptr<uchar>(i);			// On récupère l'adresse du premier élément de la ième ligne
				for ( j = 0; j < nCols; ++j)
				{
					p[j] = 255-p[j];			// On se promène sur chaque ligne (chaque composante de chaque pixel)
				}
			}
//.....................................................................
#endif
}
//=====================================================================
//					ImageProcess
//=====================================================================
int	ImageProcess(int argc, char** argv)
{
	  Mat I, J;


		if( argc < 3)
			{
				  cout << "!!! No Image Data !!!" << endl;
				  return -1;
			}

	    if( argc == 4 && !strcmp(argv[3],"G") )
			{
				I = imread(argv[2], IMREAD_GRAYSCALE);
			}
	    else
			{
				I = imread(argv[2], IMREAD_COLOR);
			}

	    if(!I.data)
			{
				cout << "!!! No Image Data !!!" << endl;
				return -1;
			}

	   	namedWindow( "Display Image", WINDOW_AUTOSIZE );
	    imshow( "Input Image", I);

	    Negative(I);
		namedWindow( "Negative", WINDOW_AUTOSIZE );
		imshow( "Negative", I );
		waitKey(0);

	    return 0;
}



